var tools = {
	dateFormat(millionsTime, pattern) {
	    var d = new Date();
	    d.setTime(millionsTime);
	    var date = {
	      "M+": d.getMonth() + 1,
	      "d+": d.getDate(),
	      "h+": d.getHours(),
	      "m+": d.getMinutes(),
	      "s+": d.getSeconds(),
	      "q+": Math.floor((d.getMonth() + 3) / 3),
	      "S+": d.getMilliseconds()
	    };
	    if (/(y+)/i.test(pattern)) {
	      pattern = pattern.replace(RegExp.$1, (d.getFullYear() + '').substr(4 - RegExp.$1.length));
	    }
	    for (var k in date) {
	      if (new RegExp("(" + k + ")").test(pattern)) {
	        pattern = pattern.replace(RegExp.$1, RegExp.$1.length == 1 ?
	          date[k] : ("00" + date[k]).substr(("" + date[k]).length));
	      }
	    }
		return pattern;
	},
	getParams () {
	  var url = window.location.href
	  if (!url.split('?')[1]){
		  return false
	  }
	  const keyValueArr = url.split('?')[1].split('&')
	  let paramObj = {}
	  keyValueArr.forEach(item => {
	    const keyValue = item.split('=')
	    paramObj[keyValue[0]] = keyValue[1]
	  })
	  return paramObj
	},
	versions () {
	  var u = navigator.userAgent,
	    app = navigator.appVersion;
	  return {
	    trident: u.indexOf('Trident') > -1, //IE内核
	    presto: u.indexOf('Presto') > -1, //opera内核
	    webKit: u.indexOf('AppleWebKit') > -1, //苹果、谷歌内核
	    gecko: u.indexOf('Gecko') > -1 && u.indexOf('KHTML') == -1, //火狐内核
	    mobile: !!u.match(/AppleWebKit.*Mobile.*/), //是否为移动终端
	    iOS: !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/), //ios终端
	    Android: u.indexOf('Android') > -1 || u.indexOf('Adr') > -1, //android终端
	    iPhone: u.indexOf('iPhone') > -1, //是否为iPhone或者QQHD浏览器
	    iPad: u.indexOf('iPad') > -1, //是否iPad
	    webApp: u.indexOf('Safari') == -1, //是否web应该程序
	    weixin: u.indexOf('MicroMessenger') > -1, //是否微信
	    QQ: u.match(/\sQQ/i) == " qq" ,//是否QQ
	    otherMac: u.indexOf('Mac OS X') > -1 // 其他的mac设备(eg: iPad Pro)
	  };
	},
	uploadMsgToApp (msg) {
	
	  console.log(msg);
	  var versions = this.versions()
	  if (versions.weixin) {
	
	  } else if (versions.Android) {
	    try {
	      window.WebViewJavascriptBridge.callHandler('uploadMsgToApp', msg);
	    } catch (e) {
	
	    }
	  } else if (versions.iOS) {
	    try {
	      window.webkit.messageHandlers.uploadMsgToApp.postMessage(msg);
	    } catch (e) {
	
	    }
	  } else if (versions.otherMac) {
	    try {
	      window.webkit.messageHandlers.uploadMsgToApp.postMessage(msg);
	    } catch (e) {
	
	    }
	  } else {
	
	  }
	}
}